if importPath==nil then importPath=string.gsub(getfenv(1)._.Name,"%.AnnotationsWindow","").."." end
if resourcePath==nil then resourcePath=string.gsub(importPath,"%.","/").."Resources/" end

annotWindow = Turbine.UI.Lotro.Window();
annotWindow:SetText(Resource[Settings.language][72]);
annotWindow:SetVisible(false);
annotWindow:SetSize(500,425);
annotWindow:SetPosition((Turbine.UI.Display:GetWidth() - annotWindow:GetWidth()) / 2,(Turbine.UI.Display:GetHeight() - annotWindow:GetHeight()) / 2);

annotWindow.AnnotationIndex=0;
annotWindow.HadErrors=false;
annotWindow.AnnotationsPanel=Turbine.UI.Control();
annotWindow.AnnotationsPanel:SetParent(annotWindow);
annotWindow.AnnotationsPanel:SetSize(annotWindow:GetWidth()-30,annotWindow:GetHeight()-100);
annotWindow.AnnotationsPanel:SetPosition(15,40);
annotWindow.AnnotationsPanel:SetBackColor(Settings.backColor);
annotWindow.AnnotationsPanel:SetMouseVisible(false);

annotWindow.AnnotationCaption=Turbine.UI.Label();
annotWindow.AnnotationCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.AnnotationCaption:SetPosition(10,3);
annotWindow.AnnotationCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.AnnotationCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.AnnotationCaption:SetForeColor(Settings.fontColor);
annotWindow.AnnotationCaption:SetText(Resource[Settings.language][73]..":");
annotWindow.AnnotationCaption:SetMouseVisible(false);

annotWindow.AnnotationList=DropDownList();
annotWindow.AnnotationList:SetParent(annotWindow.AnnotationsPanel);
annotWindow.AnnotationList:SetPosition(annotWindow.AnnotationCaption:GetLeft()+annotWindow.AnnotationCaption:GetWidth()+2,annotWindow.AnnotationCaption.GetTop()-3);
annotWindow.AnnotationList:SetSize(annotWindow.AnnotationsPanel:GetWidth()-(annotWindow.AnnotationCaption:GetWidth()+annotWindow.AnnotationCaption:GetLeft())-30,20);
annotWindow.AnnotationList:SetFont(Turbine.UI.Lotro.Font.Verdana16)
annotWindow.AnnotationList:SetBorderColor(Settings.trimColor);
annotWindow.AnnotationList:SetTextColor(Settings.listTextColor)
annotWindow.AnnotationList:SetBackColor(Settings.backColor);
annotWindow.AnnotationList:SetCurrentBackColor(Settings.backColor);
annotWindow.AnnotationList:SetDropRows(5);

annotWindow.LoadAnnotationList=function()
	local pos1;
	local localAnnotations={};
	annotWindow.AnnotationList:ClearList();
	annotWindow.AnnotationList:AddItem(Resource[Settings.language][79],0);
	--annotations[#annotations+1]={1,-12.3,-20.9, 8, 8, 19, "Gramsfoot Map"}; -- Gramsfoot map

	for tmpIndex=1,#annotations do
		if annotations[tmpIndex][1]==mapWindow.CurrentMapID and annotations[tmpIndex][5]~=8 and annotations[tmpIndex][6]==nil then
			tmpName=annotations[tmpIndex][7]
			if tmpName==nil or tmpName=="" then
				if annotations[tmpIndex][6]~=nil then
					if mapStrings[Settings.language][annotations[tmpIndex][6]]~=nil then
						tmpName=mapStrings[Settings.language][annotations[tmpIndex][6]]; -- use translated text if found
					elseif mapStrings[1][annotations[tmpIndex][6]]~=nil then
						tmpName=mapStrings[1][annotations[tmpIndex][6]]; -- fall back to english if translated text not found
					end
				end
			end
			pos1=string.find (tmpName,":",0,true);
			if (pos1~=nil)then
				tmpName=string.sub(tmpName,1,pos1-1);
			end
			localAnnotations[#localAnnotations+1]={tmpName,tmpIndex}
		end
	end
	
	-- now sort the annotations alphabetically
	table.sort(localAnnotations,function(arg1,arg2) if arg1[1]<arg2[1] then return(true) end end);
	for tmpIndex=1,#localAnnotations do
		annotWindow.AnnotationList:AddItem(localAnnotations[tmpIndex][1],localAnnotations[tmpIndex][2]);
	end
	-- force garbage collection of table
	while #localAnnotations>0 do
		table.remove(localAnnotations);
	end
	localAnnotations=nil;
end
annotWindow.AnnotationList.SelectedIndexChanged = function ()
	annotWindow:EditAnnotation(annotWindow.AnnotationList:GetValue());
end

annotWindow.TypeCaption=Turbine.UI.Label();
annotWindow.TypeCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.TypeCaption:SetPosition(10,annotWindow.AnnotationCaption:GetTop()+annotWindow.AnnotationCaption:GetHeight()+9);
annotWindow.TypeCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.TypeCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.TypeCaption:SetForeColor(Settings.fontColor);
annotWindow.TypeCaption:SetText(Resource[Settings.language][74]..":");
annotWindow.TypeCaption:SetMouseVisible(false);

annotWindow.TypeList=DropDownList();
annotWindow.TypeList:SetParent(annotWindow.AnnotationsPanel);
annotWindow.TypeList:SetPosition(annotWindow.TypeCaption:GetLeft()+annotWindow.TypeCaption:GetWidth()+2,annotWindow.TypeCaption.GetTop()-3);
annotWindow.TypeList:SetSize(annotWindow.AnnotationsPanel:GetWidth()-(annotWindow.TypeCaption:GetWidth()+annotWindow.TypeCaption:GetLeft())-30,20);
annotWindow.TypeList:SetTextColor(Settings.listTextColor)
annotWindow.TypeList:SetFont(Turbine.UI.Lotro.Font.Verdana16)
annotWindow.TypeList:SetBorderColor(Settings.trimColor);
annotWindow.TypeList:SetBackColor(Settings.backColor);
annotWindow.TypeList:SetCurrentBackColor(Settings.backColor);
annotWindow.TypeList:SetDropRows(5);

annotWindow.TypeList:AddItem(Resource[Settings.language][110],55);
annotWindow.TypeList:AddItem(Resource[Settings.language][116],11);
annotWindow.TypeList:AddItem(Resource[Settings.language][155],43);
annotWindow.TypeList:AddItem(Resource[Settings.language][156],44);
annotWindow.TypeList:AddItem(Resource[Settings.language][157],45);
annotWindow.TypeList:AddItem(Resource[Settings.language][162],46);
annotWindow.TypeList:AddItem(Resource[Settings.language][182],48);
annotWindow.TypeList:SetSelectedIndex(1);

annotWindow.TypeList.SelectedIndexChanged=function()
	annotWindow.AllegianceList:SetVisible(annotWindow.TypeList:GetValue()==11);
end

annotWindow.NSCoordCaption=Turbine.UI.Label();
annotWindow.NSCoordCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.NSCoordCaption:SetPosition(10,annotWindow.TypeCaption:GetTop()+annotWindow.TypeCaption:GetHeight()+9);
annotWindow.NSCoordCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.NSCoordCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.NSCoordCaption:SetForeColor(Settings.fontColor);
annotWindow.NSCoordCaption:SetText(Resource[Settings.language][75]..":");
annotWindow.NSCoordCaption:SetMouseVisible(false);
annotWindow.NSCoordText=Turbine.UI.Lotro.TextBox();
annotWindow.NSCoordText:SetParent(annotWindow.AnnotationsPanel);
annotWindow.NSCoordText:SetPosition(annotWindow.NSCoordCaption:GetLeft()+annotWindow.NSCoordCaption:GetWidth()+2,annotWindow.NSCoordCaption.GetTop());
annotWindow.NSCoordText:SetSize(40,18);
annotWindow.NSCoordText:SetFont(Turbine.UI.Lotro.Font.Verdana14);

annotWindow.NSButtons=RadioButtonGroup();
annotWindow.NSButtons:SetParent(annotWindow.AnnotationsPanel);
annotWindow.NSButtons:SetSize(70,20);
annotWindow.NSButtons:SetPosition(annotWindow.NSCoordText:GetLeft()+annotWindow.NSCoordText:GetWidth()+3,annotWindow.NSCoordText:GetTop()-1);
annotWindow.NSButtons.UnselectedIcon=resourcePath.."RB_unselected.tga";
annotWindow.NSButtons.SelectedIcon=resourcePath.."RB_selected.tga";
annotWindow.NSButtons.IconWidth=16;
annotWindow.NSButtons.IconHeight=16;
annotWindow.NSButtons:SetBorderColor(Settings.backColor);
annotWindow.NSButtons:SetBackColor(Settings.backColor);
annotWindow.NSButtons:SetTextColor(Settings.fontColor);
annotWindow.NSButtons:AddChoice(Resource[Settings.language][150]);
annotWindow.NSButtons:AddChoice(Resource[Settings.language][151]);
annotWindow.NSButtons:SetRows(1);
annotWindow.NSButtons:SetSelectedChoice(2);

annotWindow.EWCoordCaption=Turbine.UI.Label();
annotWindow.EWCoordCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.EWCoordCaption:SetPosition(10,annotWindow.NSCoordCaption:GetTop()+annotWindow.NSCoordCaption:GetHeight()+9);
annotWindow.EWCoordCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.EWCoordCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.EWCoordCaption:SetForeColor(Settings.fontColor);
annotWindow.EWCoordCaption:SetText(Resource[Settings.language][76]..":");
annotWindow.EWCoordCaption:SetMouseVisible(false);
annotWindow.EWCoordText=Turbine.UI.Lotro.TextBox();
annotWindow.EWCoordText:SetParent(annotWindow.AnnotationsPanel);
annotWindow.EWCoordText:SetPosition(annotWindow.EWCoordCaption:GetLeft()+annotWindow.EWCoordCaption:GetWidth()+2,annotWindow.EWCoordCaption.GetTop());
annotWindow.EWCoordText:SetSize(40,18);
annotWindow.EWCoordText:SetFont(Turbine.UI.Lotro.Font.Verdana14);

annotWindow.EWButtons=RadioButtonGroup();
annotWindow.EWButtons:SetParent(annotWindow.AnnotationsPanel);
annotWindow.EWButtons:SetSize(70,20);
annotWindow.EWButtons:SetPosition(annotWindow.EWCoordText:GetLeft()+annotWindow.EWCoordText:GetWidth()+3,annotWindow.EWCoordText:GetTop()-1);
annotWindow.EWButtons.UnselectedIcon=resourcePath.."RB_unselected.tga";
annotWindow.EWButtons.SelectedIcon=resourcePath.."RB_selected.tga";
annotWindow.EWButtons.IconWidth=16;
annotWindow.EWButtons.IconHeight=16;
annotWindow.EWButtons:SetBorderColor(Settings.backColor);
annotWindow.EWButtons:SetBackColor(Settings.backColor);
annotWindow.EWButtons:SetTextColor(Settings.fontColor);
annotWindow.EWButtons:AddChoice(Resource[Settings.language][152]);
annotWindow.EWButtons:AddChoice(Resource[Settings.language][153]);
annotWindow.EWButtons:SetRows(1);
annotWindow.EWButtons:SetSelectedChoice(2);

annotWindow.NameCaption=Turbine.UI.Label();
annotWindow.NameCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.NameCaption:SetPosition(10,annotWindow.EWCoordCaption:GetTop()+annotWindow.EWCoordCaption:GetHeight()+9);
annotWindow.NameCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.NameCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.NameCaption:SetForeColor(Settings.fontColor);
annotWindow.NameCaption:SetText(Resource[Settings.language][77]..":");
annotWindow.NameCaption:SetMouseVisible(false);
annotWindow.NameText=Turbine.UI.Lotro.TextBox();
annotWindow.NameText:SetParent(annotWindow.AnnotationsPanel);
annotWindow.NameText:SetPosition(annotWindow.NameCaption:GetLeft()+annotWindow.NameCaption:GetWidth()+2,annotWindow.NameCaption.GetTop());
annotWindow.NameText:SetSize(annotWindow.AnnotationsPanel:GetWidth()-(annotWindow.NameCaption:GetWidth()+annotWindow.NameCaption:GetLeft())-30,18);
annotWindow.NameText:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.NameText:SetMultiline(false);

annotWindow.DescriptionCaption=Turbine.UI.Label();
annotWindow.DescriptionCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.DescriptionCaption:SetPosition(10,annotWindow.NameCaption:GetTop()+annotWindow.NameCaption:GetHeight()+9);
annotWindow.DescriptionCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.DescriptionCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.DescriptionCaption:SetForeColor(Settings.fontColor);
annotWindow.DescriptionCaption:SetText(Resource[Settings.language][78]..":");
annotWindow.DescriptionCaption:SetMouseVisible(false);
annotWindow.DescriptionText=Turbine.UI.Lotro.TextBox();
annotWindow.DescriptionText:SetParent(annotWindow.AnnotationsPanel);
annotWindow.DescriptionText:SetPosition(annotWindow.DescriptionCaption:GetLeft()+annotWindow.DescriptionCaption:GetWidth()+2,annotWindow.DescriptionCaption.GetTop());
annotWindow.DescriptionText:SetSize(annotWindow.AnnotationsPanel:GetWidth()-(annotWindow.DescriptionCaption:GetWidth()+annotWindow.DescriptionCaption:GetLeft())-30,72);
annotWindow.DescriptionText:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.DescriptionText:SetMultiline(true);

annotWindow.AllegianceCaption=Turbine.UI.Label();
annotWindow.AllegianceCaption:SetParent(annotWindow.AnnotationsPanel);
annotWindow.AllegianceCaption:SetPosition(10,annotWindow.DescriptionText:GetTop()+annotWindow.DescriptionText:GetHeight()+9);
annotWindow.AllegianceCaption:SetSize(annotWindow.AnnotationsPanel:GetWidth()-350,18);
annotWindow.AllegianceCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.AllegianceCaption:SetForeColor(Settings.fontColor);
annotWindow.AllegianceCaption:SetText(Resource[Settings.language][67]..":");
annotWindow.AllegianceCaption:SetMouseVisible(false);

annotWindow.AllegianceNA=Turbine.UI.Label();
annotWindow.AllegianceNA:SetParent(annotWindow.AnnotationsPanel);
annotWindow.AllegianceNA:SetPosition(annotWindow.AllegianceCaption:GetLeft()+annotWindow.AllegianceCaption:GetWidth()+2,annotWindow.AllegianceCaption.GetTop()-3);
annotWindow.AllegianceNA:SetSize(annotWindow.AnnotationsPanel:GetWidth()-(annotWindow.AllegianceCaption:GetWidth()+annotWindow.AllegianceCaption:GetLeft())-30,20);
annotWindow.AllegianceNA:SetFont(Turbine.UI.Lotro.Font.Verdana14);
annotWindow.AllegianceNA:SetBackColor(Settings.backColor);
annotWindow.AllegianceNA:SetForeColor(Settings.fontColor);
annotWindow.AllegianceNA:SetText(Resource[Settings.language][199]);

annotWindow.AllegianceList=DropDownList();
annotWindow.AllegianceList:SetParent(annotWindow.AnnotationsPanel);
annotWindow.AllegianceList:SetPosition(annotWindow.AllegianceCaption:GetLeft()+annotWindow.AllegianceCaption:GetWidth()+2,annotWindow.AllegianceCaption.GetTop()-3);
annotWindow.AllegianceList:SetSize(annotWindow.AnnotationsPanel:GetWidth()-(annotWindow.AllegianceCaption:GetWidth()+annotWindow.AllegianceCaption:GetLeft())-30,20);
annotWindow.AllegianceList:SetBorderColor(Settings.trimColor);
annotWindow.AllegianceList:SetTextColor(Settings.listTextColor)
annotWindow.AllegianceList:SetBackColor(Settings.backColor);
annotWindow.AllegianceList:SetCurrentBackColor(Settings.backColor);
annotWindow.AllegianceList:SetDropRows(5);

annotWindow.AllegianceList:AddItem(Resource[Settings.language][198],1); -- none
annotWindow.AllegianceList:AddItem(Resource[Settings.language][68],2); -- creep
annotWindow.AllegianceList:AddItem(Resource[Settings.language][69],3); -- freep
annotWindow.AllegianceList:AddItem(Resource[Settings.language][70],4); -- delving
annotWindow.AllegianceList:SetSelectedIndex(1);
annotWindow.AllegianceList:SetVisible(false);

--** SAVE AND CANCEL
annotWindow.SaveButton=Turbine.UI.Lotro.Button();
annotWindow.SaveButton:SetParent(annotWindow);
annotWindow.SaveButton:SetSize(120,20);
annotWindow.SaveButton:SetFont(Turbine.UI.Lotro.Font.Verdana18)
annotWindow.SaveButton:SetPosition((annotWindow:GetWidth()-annotWindow.SaveButton:GetWidth()*3)/4,annotWindow:GetHeight()-35);
annotWindow.SaveButton:SetText(Resource[Settings.language][11]);
annotWindow.SaveButton.Click=function()
	local hasError=false;
	-- validate option values
	-- verify that the coordinates land on the current map
	local X=tonumber(annotWindow.EWCoordText:GetText());
	if X<0 then X=0-X end -- we account for negatives with the buttons
	if annotWindow.EWButtons:GetSelectedChoice()==2 then X=0-X end
	X=math.floor(X*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
	local Y=tonumber(annotWindow.NSCoordText:GetText())
	if Y<0 then Y=0-Y end
	if annotWindow.NSButtons:GetSelectedChoice()==2 then Y=0-Y end
	Y=math.floor(Y*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
	if X<1 or X>mapInfo[mapWindow.CurrentMapID][4] then
		hasError=true;
		annotWindow.EWCoordCaption:SetForeColor(Turbine.UI.Color(1,0,0));
	end
	if Y<1 or Y>mapInfo[mapWindow.CurrentMapID][5] then
		hasError=true;
		annotWindow.NSCoordCaption:SetForeColor(Turbine.UI.Color(1,0,0));
	end
	annotWindow.NameText:SetText(string.ltrim(annotWindow.NameText:GetText()));
	annotWindow.DescriptionText:SetText(string.ltrim(annotWindow.DescriptionText:GetText()));
	if annotWindow.NameText:GetText()=="" or string.find(annotWindow.NameText:GetText(),":",nil,true)~=nil then
		hasError=true;
		annotWindow.NameCaption:SetForeColor(Turbine.UI.Color(1,0,0));
	end
	if annotWindow.DescriptionText:GetText()=="" or string.find(annotWindow.DescriptionText:GetText(),":",nil,true)~=nil then
		hasError=true;
		annotWindow.DescriptionCaption:SetForeColor(Turbine.UI.Color(1,0,0));
	end

-- verify that name is non-blank and contains no ":"
-- verify that description is non-blank

	if hasError then
		annotWindow.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
		annotWindow.ErrorLabel:SetText(Resource[Settings.language][80]);
		annotWindow.ErrorLabel:SetVisible(true);
		annotWindow.HadErrors=true;
		annotWindow.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
		annotWindow:SetWantsUpdates(true);
	else
		local tmpAnnotationIndex;
		if annotWindow.AnnotationList:GetValue()==0 then
			-- if creating a new annotation, we need to figure out where to put it in the alphabetical list
			tmpAnnotationIndex=#annotations+1;
			annotations[tmpAnnotationIndex]={};
			annotations[tmpAnnotationIndex][1]=mapWindow.CurrentMapID;
			if annotWindow.NSButtons:GetSelectedChoice()==1 then
				annotations[tmpAnnotationIndex][2]=tonumber(annotWindow.NSCoordText:GetText());
			else
				annotations[tmpAnnotationIndex][2]=0-tonumber(annotWindow.NSCoordText:GetText());
			end
			if annotWindow.EWButtons:GetSelectedChoice()==1 then
				annotations[tmpAnnotationIndex][3]=tonumber(annotWindow.EWCoordText:GetText());
			else
				annotations[tmpAnnotationIndex][3]=0-tonumber(annotWindow.EWCoordText:GetText());
			end
			annotations[tmpAnnotationIndex][4]=annotWindow.TypeList:GetValue();
			if annotWindow.AllegianceList:IsVisible() then
				annotations[tmpAnnotationIndex][5]=annotWindow.AllegianceList:GetValue();
			else
				annotations[tmpAnnotationIndex][5]=1;
			end
			annotations[tmpAnnotationIndex][6]=nil;
			annotations[tmpAnnotationIndex][7]=annotWindow.NameText:GetText()..": "..string.ltrim(annotWindow.DescriptionText:GetText());
			annotations[tmpAnnotationIndex][8]=0;
			annotations[tmpAnnotationIndex][9]=0;
			annotations[tmpAnnotationIndex][10]=0;
			annotations[tmpAnnotationIndex][11]=0;
			annotWindow.LoadAnnotationList(); --note, tmpAnnotationIndex will no longer be valid after this operation
			local tmpValue;
			for tmpIndex=2,annotWindow.AnnotationList.ListData:GetItemCount() do
				tmpValue=annotWindow.AnnotationList.ListData:GetItem(tmpIndex):GetValue();
				if annotations[annotWindow.AnnotationList.ListData:GetItem(tmpIndex):GetValue()][7]==annotWindow.NameText:GetText()..": "..string.ltrim(annotWindow.DescriptionText:GetText()) then
					annotWindow.AnnotationList:SetSelectedIndex(tmpIndex);
					annotWindow:EditAnnotation(tmpValue);
					break;
				end
			end
		else
			-- if modifying an existing annotation, only update the Coords and type if it is not a "default"
			tmpAnnotationIndex=annotWindow.AnnotationList:GetValue();
			if annotations[tmpAnnotationIndex][6]==nil then
				if annotWindow.NSButtons:GetSelectedChoice()==1 then
					annotations[tmpAnnotationIndex][2]=tonumber(annotWindow.NSCoordText:GetText());
				else
					annotations[tmpAnnotationIndex][2]=0-tonumber(annotWindow.NSCoordText:GetText());
				end
				if annotWindow.EWButtons:GetSelectedChoice()==1 then
					annotations[tmpAnnotationIndex][3]=tonumber(annotWindow.EWCoordText:GetText());
				else
					annotations[tmpAnnotationIndex][3]=0-tonumber(annotWindow.EWCoordText:GetText());
				end
				annotations[tmpAnnotationIndex][4]=annotWindow.TypeList:GetValue();
				if annotWindow.AllegianceList:IsVisible() then
					annotations[tmpAnnotationIndex][5]=annotWindow.AllegianceList:GetValue();
				else
					annotations[tmpAnnotationIndex][5]=1;
				end
			end
			-- -- we have no way of auto-translating, so that is the best we can do
			-- only update the name and description even if the type or coords were somehow enabled
			annotations[tmpAnnotationIndex][7]=annotWindow.NameText:GetText()..": "..string.ltrim(annotWindow.DescriptionText:GetText());
			annotWindow.AnnotationList.ListData:GetItem(annotWindow.AnnotationList.ListData:GetSelectedIndex()):SetText(annotWindow.NameText:GetText());
			annotWindow.AnnotationList.CurrentValue:SetText(annotWindow.NameText:GetText());
		end

		annotWindow.ErrorLabel:SetForeColor(Turbine.UI.Color(0,1,0));
		annotWindow.ErrorLabel:SetText(Resource[Settings.language][81]);
		annotWindow.ErrorLabel:SetVisible(true);
		annotWindow.HadErrors=true;
		annotWindow.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
		annotWindow:SetWantsUpdates(true);

		mapWindow.NeedsRefresh=true;
		mapWindow:SetWantsUpdates(true);
	end
end

annotWindow.ReloadButton=Turbine.UI.Lotro.Button();
annotWindow.ReloadButton:SetParent(annotWindow);
annotWindow.ReloadButton:SetSize(annotWindow.SaveButton:GetWidth(),20);
annotWindow.ReloadButton:SetFont(Turbine.UI.Lotro.Font.Verdana18)
annotWindow.ReloadButton:SetPosition(annotWindow.SaveButton:GetLeft()+annotWindow.SaveButton:GetWidth()+(annotWindow:GetWidth()-annotWindow.ReloadButton:GetWidth()*3)/4,annotWindow:GetHeight()-35);
annotWindow.ReloadButton:SetText(Resource[Settings.language][64]);
annotWindow.ReloadButton.Click=function()
	annotWindow:SetWantsUpdates(true);
	iconInfo=nil -- clear the icon info so it reloads
	mapInfo=nil -- clear the map info so it reloads
	AddDefaultOverlays();
	RefreshMap(0); -- this will reload the current map, but force a reload of the annotations
end

annotWindow.DeleteButton=Turbine.UI.Lotro.Button();
annotWindow.DeleteButton:SetParent(annotWindow);
annotWindow.DeleteButton:SetSize(annotWindow.SaveButton:GetWidth(),20);
annotWindow.DeleteButton:SetFont(Turbine.UI.Lotro.Font.Verdana18)
annotWindow.DeleteButton:SetPosition(annotWindow.ReloadButton:GetLeft()+annotWindow.ReloadButton:GetWidth()+(annotWindow:GetWidth()-annotWindow.DeleteButton:GetWidth()*3)/4,annotWindow:GetHeight()-35);
annotWindow.DeleteButton:SetText(Resource[Settings.language][84]);
annotWindow.DeleteButton.Click=function()
	-- users can delete anything that shows up in the list since the list doesn't have map points :)
	if annotWindow.AnnotationList:GetValue()>0 then
		table.remove(annotations,annotWindow.AnnotationList:GetValue());
		annotWindow.LoadAnnotationList(); --note, tmpAnnotationIndex will no longer be valid after this operation
		-- now point to the "New" entry
		annotWindow.AnnotationList:SetSelectedIndex(1);
		annotWindow.ErrorLabel:SetForeColor(Turbine.UI.Color(0,1,0));
		annotWindow.ErrorLabel:SetText(Resource[Settings.language][85]);
		annotWindow.ErrorLabel:SetVisible(true);
		annotWindow.HadErrors=true;
		annotWindow.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
		annotWindow:SetWantsUpdates(true);

		mapWindow.NeedsRefresh=true;
		mapWindow:SetWantsUpdates(true);
	end
end

annotWindow.ErrorLabel=Turbine.UI.Label();
annotWindow.ErrorLabel:SetParent(annotWindow);
annotWindow.ErrorLabel:SetText("")
annotWindow.ErrorLabel:SetSize(annotWindow:GetWidth()-30,18);
annotWindow.ErrorLabel:SetPosition((annotWindow:GetWidth()-annotWindow.ErrorLabel:GetWidth())/2,annotWindow.SaveButton:GetTop()-annotWindow.ErrorLabel:GetHeight()-5);
annotWindow.ErrorLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18);
annotWindow.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
annotWindow.ErrorLabel:SetVisible(false);
annotWindow.ErrorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
annotWindow.ErrorLabel:SetMouseVisible(false);

annotWindow.VisibleChanged=function(sender,args)
	if annotWindow:IsVisible() then
		-- refresh the options status to reflect current values
		annotWindow:SetLanguage(Settings.language);
	end
end
annotWindow.Update=function(sender,args)
	if annotWindow.HadErrors then
		if Turbine.Engine:GetGameTime()>annotWindow.ErrorFadeTime then
			annotWindow.EWCoordCaption:SetForeColor(Settings.fontColor);
			annotWindow.NSCoordCaption:SetForeColor(Settings.fontColor);
			annotWindow.NameCaption:SetForeColor(Settings.fontColor);
			annotWindow.DescriptionCaption:SetForeColor(Settings.fontColor);
			annotWindow:SetWantsUpdates(false);
			annotWindow.ErrorLabel:SetVisible(false);
			annotWindow.HadErrors=false
		end
	end
end

annotWindow.NSCoordText:SetZOrder(50);
annotWindow.EWCoordText:SetZOrder(60);
annotWindow.NameText:SetZOrder(70);
annotWindow.DescriptionText:SetZOrder(80);

annotWindow.TypeList:SetZOrder(90);
annotWindow.AnnotationList:SetZOrder(100);

annotWindow.SelectAnnotation=function(sender,annotationIndex)
	for tmpIndex=1,annotWindow.AnnotationList.ListData:GetItemCount() do
		if annotWindow.AnnotationList.ListData:GetItem(tmpIndex):GetValue()==annotationIndex then
			annotWindow.AnnotationList:SetSelectedIndex(tmpIndex);
			annotWindow:EditAnnotation(annotationIndex);
			break
		end
	end
end
annotWindow.EditAnnotation=function(sender,annotationIndex)
	local tmpName;
	local tmpDescription;
	local pos1;
	annotWindow.AnnotationIndex=annotationIndex;

-- all annotations have the form:{MapID, N/S, E/W, IconID, Allegiance, TextID, Description, NPCRank/MapID/Tier, NPC Type, QuestType, SpecialLoot}
	annotWindow.TypeList:HideList();
	if annotationIndex==nil or annotationIndex<1 then
		annotWindow.TypeList:SetEnabled(true);
		annotWindow.NSCoordText:SetEnabled(true);
		annotWindow.EWCoordText:SetEnabled(true);
		annotWindow.NameText:SetEnabled(true);
		annotWindow.DescriptionText:SetEnabled(true);
		annotWindow.AllegianceList:SetEnabled(true);
	else
		tmpName=annotations[annotationIndex][7]
		if tmpName==nil or tmpName=="" then
			if annotations[annotationIndex][6]~=nil then
				if mapStrings[Settings.language][annotations[annotationIndex][6]]~=nil then
					tmpName=mapStrings[Settings.language][annotations[annotationIndex][6]]; -- use translated text if found
				elseif mapStrings[1][annotations[annotationIndex][6]]~=nil then
					tmpName=mapStrings[1][annotations[annotationIndex][6]]; -- fall back to english if translated text not found
				end
			end
		end
		pos1=string.find (tmpName,":",0,true);
		if (pos1~=nil)then
			tmpDescription=string.ltrim(string.sub(tmpName,pos1+1));
			tmpName=string.sub(tmpName,1,pos1-1);
		end

		for tmpIndex=1,annotWindow.TypeList.ListData:GetItemCount() do
			if annotWindow.TypeList.ListData:GetItem(tmpIndex):GetValue()==annotations[annotationIndex][4] then
				annotWindow.TypeList:SetSelectedIndex(tmpIndex);
				break;
			end
		end

		local NSCoord=annotations[annotationIndex][2];
		local EWCoord=annotations[annotationIndex][3];
		if EWCoord<0 then
			annotWindow.EWCoordText:SetText(tostring(0-EWCoord));
			annotWindow.EWButtons:SetSelectedChoice(2)
		else
			annotWindow.EWCoordText:SetText(tostring(EWCoord));
			annotWindow.EWButtons:SetSelectedChoice(1)
		end
		if NSCoord<0 then
			annotWindow.NSCoordText:SetText(tostring(0-NSCoord));
			annotWindow.NSButtons:SetSelectedChoice(2)
		else
			annotWindow.NSCoordText:SetText(tostring(NSCoord));
			annotWindow.NSButtons:SetSelectedChoice(1)
		end

		local allegiance=annotations[annotationIndex][5];
		if allegiance==nil or allegiance<1 then allegiance=1 end
		annotWindow.AllegianceList:SetSelectedIndex(allegiance);
		annotWindow.AllegianceList:SetVisible(annotWindow.TypeList:GetValue()==11);

		annotWindow.NameText:SetText(tmpName);
		annotWindow.DescriptionText:SetText(tmpDescription);
		if annotations[annotationIndex][6]==nil then
			annotWindow.TypeList:SetEnabled(true);
			annotWindow.NSCoordText:SetEnabled(true);
			annotWindow.EWCoordText:SetEnabled(true);
			annotWindow.NameText:SetEnabled(true);
			annotWindow.DescriptionText:SetEnabled(true);
			annotWindow.AllegianceList:SetEnabled(true);
		else
			annotWindow.TypeList:SetEnabled(false);
			annotWindow.NSCoordText:SetEnabled(false);
			annotWindow.EWCoordText:SetEnabled(false);
			annotWindow.NameText:SetEnabled(true);
			annotWindow.DescriptionText:SetEnabled(true);
			annotWindow.AllegianceList:SetEnabled(false);
		end
	end
end

annotWindow.SetTrimColor=function()
	annotWindow.AnnotationList:SetBorderColor(Settings.trimColor);
	annotWindow.TypeList:SetBorderColor(Settings.trimColor);
	annotWindow.AllegianceList:SetBorderColor(Settings.trimColor);
end
annotWindow.SetBackColor=function()
	annotWindow.AnnotationsPanel:SetBackColor(Settings.backColor);
	annotWindow.AnnotationList:SetBackColor(Settings.backColor);
	annotWindow.AnnotationList:SetCurrentBackColor(Settings.backColor);
	annotWindow.TypeList:SetBackColor(Settings.backColor);
	annotWindow.TypeList:SetCurrentBackColor(Settings.backColor);
	annotWindow.NSButtons:SetBorderColor(Settings.backColor);
	annotWindow.NSButtons:SetBackColor(Settings.backColor);
	annotWindow.EWButtons:SetBorderColor(Settings.backColor);
	annotWindow.EWButtons:SetBackColor(Settings.backColor);
	annotWindow.AllegianceNA:SetBackColor(Settings.backColor);
	annotWindow.AllegianceList:SetBackColor(Settings.backColor);
	annotWindow.AllegianceList:SetCurrentBackColor(Settings.backColor);
end
annotWindow.SetFontColor=function()
	annotWindow.AnnotationCaption:SetForeColor(Settings.fontColor);
	annotWindow.TypeCaption:SetForeColor(Settings.fontColor);
	annotWindow.NSCoordCaption:SetForeColor(Settings.fontColor);
	annotWindow.NSButtons:SetTextColor(Settings.fontColor);
	annotWindow.EWCoordCaption:SetForeColor(Settings.fontColor);
	annotWindow.EWButtons:SetTextColor(Settings.fontColor);
	annotWindow.NameCaption:SetForeColor(Settings.fontColor);
	annotWindow.DescriptionCaption:SetForeColor(Settings.fontColor);
	annotWindow.AllegianceCaption:SetForeColor(Settings.fontColor);
	annotWindow.AllegianceNA:SetForeColor(Settings.fontColor);
end
annotWindow.SetHeadingsColor=function()
end
annotWindow.SetListTextColor=function()
	annotWindow.AnnotationList:SetTextColor(Settings.listTextColor)
	annotWindow.TypeList:SetTextColor(Settings.listTextColor)
	annotWindow.AllegianceList:SetTextColor(Settings.listTextColor)
end

annotWindow.SetLanguage=function()
	annotWindow:SetText(Resource[Settings.language][72]);
	annotWindow.AnnotationCaption:SetText(Resource[Settings.language][73]..":");
	annotWindow.AnnotationList.ListData:GetItem(1):SetText(Resource[Settings.language][79]);
	annotWindow.SaveButton:SetText(Resource[Settings.language][11]);
	annotWindow.ReloadButton:SetText(Resource[Settings.language][64]);
	annotWindow.TypeCaption:SetText(Resource[Settings.language][74]..":");

	annotWindow.TypeList.ListData:GetItem(1):SetText(Resource[Settings.language][110]);
	annotWindow.TypeList.ListData:GetItem(2):SetText(Resource[Settings.language][116]);
	annotWindow.TypeList.ListData:GetItem(3):SetText(Resource[Settings.language][155]);
	annotWindow.TypeList.ListData:GetItem(4):SetText(Resource[Settings.language][156]);
	annotWindow.TypeList.ListData:GetItem(5):SetText(Resource[Settings.language][157]);
	annotWindow.TypeList.ListData:GetItem(6):SetText(Resource[Settings.language][162]);

	annotWindow.AllegianceNA:SetText(Resource[Settings.language][199]);
	annotWindow.AllegianceCaption:SetText(Resource[Settings.language][67]..":");
	annotWindow.AllegianceList.ListData:GetItem(1):SetText(Resource[Settings.language][198]); -- none
	annotWindow.AllegianceList.ListData:GetItem(2):SetText(Resource[Settings.language][68]); -- creep
	annotWindow.AllegianceList.ListData:GetItem(3):SetText(Resource[Settings.language][69]); -- freep
	annotWindow.AllegianceList.ListData:GetItem(4):SetText(Resource[Settings.language][70]); -- delving

	annotWindow.NSCoordCaption:SetText(Resource[Settings.language][75]..":");
	annotWindow.EWCoordCaption:SetText(Resource[Settings.language][76]..":");
	annotWindow.NameCaption:SetText(Resource[Settings.language][77]..":");
	annotWindow.DescriptionCaption:SetText(Resource[Settings.language][78]..":");
	annotWindow.DeleteButton:SetText(Resource[Settings.language][84]);
end
annotWindow.MouseClick=function(sender,args)
	annotWindow.AnnotationList:HideList();
	annotWindow.TypeList:HideList();
end
